unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2:TButton;
    Button3:TButton;
    Image1: TImage;
    Image2: TImage;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender:TObject);
    procedure Button3Click(Sender:TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  FPImage, FPWritePNG, IntfGraphics;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  destBmp: TBitmap;
  srcImg, destImg: TLazIntfImage;
  clr: TFPColor;
  x,y: Integer;
begin
  // Create an alpha-transparent bitmap for the destination image
  destBmp := TBitmap.Create;
  try
    destBmp.PixelFormat := pf32Bit;      // IMPORTANT!
    // Convert the source bitmap (that from Image1) to a TLazIntfImage
    srcImg := Image1.Picture.Bitmap.CreateIntfImage;
    // Convert the (still empty) destination bitmap to a TLazIntfImage
    destImg := destBmp.CreateIntfImage;
    try
      destImg.SetSize(srcImg.Width, srcImg.Height);
      // Get the color in the source image which should become alpha-transparent
      clr := srcImg.Colors[0, 0];
      // Now iterate over all pixels. In the destination image, all pixels which
      // have the "transparent color" will become alpha-transparent, all others
      // will get the color from the source image.
      for y := 0 to srcimg.Height-1 do
        for x := 0 to srcimg.Width-1 do
          if srcimg.Colors[x, y] = clr then
            destImg.Colors[x, y] := colTransparent
          else
            destImg.Colors[x, y] := srcImg[x, y];

      // Convert the destination LazIntfImage back to a bitmap...
      destBmp.LoadFromIntfImage(destImg);
      // ... and assign the bitmap to the bitmap of the TImage component.
      Image2.Picture.Assign(destBmp);
    finally
      destImg.Free;
      srcImg.Free;

      Button2.Enabled := true;
      Button3.enabled := true;
    end;
  finally
    destBmp.Free;
  end;
end;

procedure TForm1.Button2Click(Sender:TObject);
begin
  Image2.Picture.Png.SaveToFile('test-1.png');
end;

procedure TForm1.Button3Click(Sender:TObject);
var
  png: TPortableNetworkGraphic;
  img: TLazIntfImage;
  writer: TFPWriterPNG;
begin
  png := TPortableNetworkGraphic.Create;
  try
    png.Assign(Image2.Picture.Bitmap);
    img := png.CreateIntfImage;
    try
      writer := TFPWriterPNG.Create;
      try
        writer.UseAlpha := true;
        img.SaveToFile('test-2.png', writer);
      finally
        writer.Free;
      end;
    finally
      img.Free;
    end;
  finally
    png.Free;
  end;
end;


end.

